<template>
  <div class="specialTool">

    <div class="bottomwrapper" :class="{ 'top-btn-active': viewer1Show && isLand }">
      <div class="imgbox" @click="tdglHandle">
        <img src="@assets/img/new/tudiguanli.png" alt="" />
      </div>
      <div class="textbox">
        <span> 土地管理 </span>
      </div>
    </div>

    <div class="bottomwrapper" @click="historyHandle" :class="{ 'top-btn-active': viewer1Show && !isLand }">
      <div class="imgbox">
        <img src="@assets/img/new/chengshigengxin.png" alt="" />
      </div>
      <div class="textbox">
        <span> 历史影像 </span>
      </div>
    </div>
    <div class="bottomwrapper csbj" @click="spjkHandle" :class="{ 'top-btn-active': !isShowSPJK }">
      <div class="imgbox">
        <img src="@assets/img/new/spjk.png" alt="" />
      </div>
      <div class="textbox">
        <span>视频监控</span>
      </div>
    </div>


    <div class="bottomwrapper spjk" @click="shoujixinling" :class="{ 'top-btn-active': !isShowSjxl }">
      <div class="imgbox">
        <img src="@assets/img/new/sjxl.png" alt="" />
      </div>
      <div class="textbox">
        <span> 手机信令 </span>
      </div>
    </div>


    <div class="bottomwrapper jxmx">
      <el-dropdown trigger="click" @command="handleCommand">
        <div class="imgbox">
          <img src="@assets/img/new/jingximoxing.png" alt="" />
        </div>
        <div class="textbox">
          <span> 精模示范 </span>
        </div>
        <el-dropdown-menu slot="dropdown" :append-to-body="false" class="popper-dropdown">
          <el-dropdown-item command="fcfhHandle">分层分户</el-dropdown-item>
          <!-- <el-dropdown-item command="sprhHandle">场景视频融合</el-dropdown-item> -->
          <el-dropdown-item v-if="isShowSPRH" command="jiqirendahui">场景视频融合</el-dropdown-item>
          <el-dropdown-item v-else command="jiqirendahui">关闭视频融合</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <div class="funcBox" v-if="testSHIPINRONGHE">
      <el-form ref="form" label-width="80px">
        <el-form-item label="四周方向:">
          <!-- <el-slider
            :min="0"
            :max="360"
            v-model="videoList[0].heading"
            @input="updateVideo"
          >
          </el-slider> -->
          <el-slider :min="0" :max="360" v-model="robotVideoList[3].heading" @input="updateVideo">
          </el-slider>
        </el-form-item>
        <el-form-item label="俯仰角度:">
          <el-slider :min="-89" :max="89" v-model="robotVideoList[3].pitch" @input="updateVideo">
          </el-slider>
        </el-form-item>
        <el-form-item label="水平视角:">
          <el-slider :min="30" :max="120" v-model="robotVideoList[3].horizonAngle" @input="updateVideo">
          </el-slider>
        </el-form-item>
        <el-form-item label="垂直视角:">
          <el-slider :min="30" :max="120" v-model="robotVideoList[3].verticalAngle" @input="updateVideo">
          </el-slider>
        </el-form-item>
        <el-form-item label="最远投射:">
          <el-slider :min="100" :max="300" v-model="robotVideoList[3].far" @input="updateVideo">
          </el-slider>
        </el-form-item>
        <el-form-item label="透明度:">
          <el-slider :step="0.1" :min="0" :max="1" v-model="robotVideoList[3].alpha" @input="updateVideo">
          </el-slider>
        </el-form-item>
      </el-form>
    </div>


  </div>
</template>

<style scoped>
.specialTool {
  width: 550px;
  position: absolute;
  bottom: 65px;
  color: #fff;
  left: 50%;
  transform: translateX(-50%);
  z-index: 99999;
  pointer-events: all;
  display: flex;
  justify-content: space-between;
}



.specialTool .bottomwrapper:nth-of-type(3) {
  /* background: red; */
  position: relative;
  top: -30px;
}

.specialTool .bottomwrapper:nth-of-type(2),
.specialTool .bottomwrapper:nth-of-type(4) {
  /* background: red; */
  position: relative;
  top: -18px;
}

.bottomwrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  cursor: pointer;
}

.imgbox {
  width: 110px;
  height: 90px;
  background-image: url("~@/assets/img/new/b1.png");
  background-size: 100% 100%;
  position: relative;
}

.imgbox:hover {
  background-image: url("~@/assets/img/new/h1.png");
}

.imgbox img {
  width: 32px;
  position: absolute;
  top: 37%;
  left: 50%;
  transform: translate(-50%, -50%);
}

.textbox {
  margin-top: 2px;
  width: 100px;
  height: 28px;
  background-image: url("~@/assets/img/new/textbg.png");
  background-size: 100% 100%;
}

.textbox span {
  text-align: center;
  display: block;
  font-size: 20px;
  font-family: Source Han Sans SC;
  font-weight: 400;
  color: #ffffff;
  line-height: 28px;
  text-shadow: 0px 2px 2px rgba(32, 32, 32, 0.8);
}

.list {
  position: absolute;
  background: rgba(14, 50, 143, 0.6);
  bottom: 124px;
  box-shadow: 0px 0px 10px 5px rgba(11, 78, 179, 0.7) inset;
}

.list li {
  min-width: 154px;
  height: 35px;
  text-align: center;
  line-height: 35px;
}

.specialTool i {
  background-image: url("~@/assets/img/new/bottomBox.png");
  background-size: 100% 100%;
  box-shadow: 0px 0px 5px 3px #fff;
}

.el-dropdown-menu {
  background: rgba(14, 50, 143, 0.6);
  box-shadow: 0px 0px 9px 3px rgba(20, 105, 233, 0.7) inset;
  text-align: center;
  width: 155px;
  border: none;
}

.el-dropdown /deep/ .el-dropdown-selfdefine {
  margin-left: 0 !important;
}

.csbj .el-dropdown-menu {
  top: -180px !important;
  left: -30.5% !important;
}

.jxmx .el-dropdown-menu {
  top: -110px !important;
  left: -26.5% !important;
}

.el-dropdown-menu /deep/ .el-dropdown-menu__item {
  color: #fff;
  line-height: 35px;
}

.el-dropdown-menu /deep/ .popper__arrow {
  border: none;
}

.csbj .el-popper /deep/ .popper__arrow::after {
  margin: 0;
  border-top-color: rgba(14, 50, 143, 0.6);
  border-top-width: 6px;
  border-bottom-width: 0;
  top: 166px;
  left: 31px;
}

.jxmx .el-popper /deep/ .popper__arrow::after {
  margin: 0;

  border-top-color: rgba(14, 50, 143, 0.6);
  border-top-width: 6px;
  border-bottom-width: 0;
  top: 96px;
  left: -32px;
}

.el-dropdown-menu__item:focus,
.el-dropdown-menu__item:not(.is-disabled):hover {
  background: rgba(18, 80, 172, 0.6);
  box-shadow: 0px 0px 10px 5px rgba(0, 132, 255, 0.7) inset;
}

.specialTool i:hover {
  box-shadow: 0px 0px 5px 3px rgba(0, 168, 255, 0.16);
}

.top-btn-active .imgbox {
  background-image: url("~@/assets/img/new/h1.png");
  background-size: 100% 100%;
}

.scroll_div {
  background: rgba(0, 0, 0, 0.4);
  padding: 5px;
  border-radius: 5px;
  bottom: 50px;
  position: absolute;
  /* right: 0px; */
  margin-left: -1052px;
  display: none;
}

.scroll_div li {
  padding: 10px;
}

.scroll_div li:hover {
  color: #0987ff;
}

.funcBox {
  width: 230px;
  position: absolute;
  top: -700px;
  left: -500px;
}
</style>

<script>
let video;
let video2;
let video3;
let video4;
let heatMapItem;
import { mapState, mapMutations } from "vuex";
import { queryBySquare } from "@/utils/request";
import Bus from "../tools/Bus";
import { roman } from "../../assets/json/index.js";
import URLInCode from "@/assets/js/urlInCode";

import axios from "axios";
export default {
  components: {

  },
  name: "bottom-menu",
  data() {
    return {
      isShowSPJK: true,
      isShowSjxl: true,
      isShowSPRH: true,
      csbjShow: false,
      jxmxShow: false,
    
      romanOption: [
        { name: "核心区" },
        { name: "景观绿地" },
        { name: "政务服务" },
      ],
      showFlag: false,
      showQYTJ: false,
      testSHIPINRONGHE: false,
      videoList: [
        {
          name: "video2",
          lon: 116.51507,
          lat: 39.79686,
          height: 40,
          isLand: true,
          // 四周方向
          heading: 305,
          // 俯仰角度
          pitch: -41,
          // 水平角度
          horizonAngle: 68,
          // 垂直角度
          verticalAngle: 103,
          // 透明度
          alpha: 1,
          // 透明度
          far: 3000,
          cameraIndexCode: "2b046ef675704975a8d45f1b00cd946b",
        },
      ],
      robotVideoList: [
        {
          name: "320959永昌南路交景园街路口南北向南",
          lon: 116.52401,
          lat: 39.77835,
          height: 60,
          // 四周方向
          heading: 346,
          // 俯仰角度
          pitch: -53,
          // 水平角度
          horizonAngle: 34,
          // 垂直角度
          verticalAngle: 61,
          // 透明度
          alpha: 1,
          // 透明度
          far: 3000,
          cameraIndexCode: "0e773649afad430e9424a89c51795658",
        },
        {
          name: "322734会展中心东侧永昌南路北向南-2",
          lon: 116.52148,
          lat: 39.78185,
          height: 50,
          // 四周方向
          heading: 329,
          // 俯仰角度
          pitch: -40,
          // 水平角度
          horizonAngle: 30,
          // 垂直角度
          verticalAngle: 56,
          // 透明度
          alpha: 1,
          // 透明度
          far: 3000,
          cameraIndexCode: "8e68b4269b89477e943ad109e5a78501",
        },
        {
          name: "320438荣昌东街交通服务中心",
          lon: 116.51829,
          lat: 39.78184,
          height: 40,
          // 四周方向
          heading: 60,
          // 俯仰角度
          pitch: -40,
          // 水平角度
          horizonAngle: 42,
          // 垂直角度
          verticalAngle: 79,
          // 透明度
          alpha: 1,
          // 透明度
          far: 3000,
          cameraIndexCode: "ad2bb399f60d48a6845638a775b8eb9f",
        },
        {
          name: "景园街与宏达南路南向北电警",
          lon: 116.52017,
          lat: 39.77687,
          height: 50,
          // 四周方向
          heading: 327,
          // 俯仰角度
          pitch: -40,
          // 水平角度
          horizonAngle: 51,
          // 垂直角度
          verticalAngle: 70,
          // 透明度
          alpha: 1,
          // 透明度
          far: 3000,
          cameraIndexCode: "de3bbfa61527413fa0414437267e15f6",
        },
      ],
      robotvideoarrList: [],

      // 四周方向
      heading: 64,
      // 俯仰角度
      pitch: -47,
      // 水平角度
      horizonAngle: 30,
      // 垂直角度
      verticalAngle: 60,
      // 透明度
      alpha: 1,
      // 透明度
      far: 166,
      videoarrList: [],
    };
  },
  computed: {
    ...mapState(["viewer1Show", "isLand", "yqfk", "qyEchartsShow"]),
  },
  methods: {
    ...mapMutations(["setViewer1Show", "setIsLand", "setqyEchartsShow"]),
    showList(index) {
      switch (index) {
        case "csbj":
          this.csbjShow = !this.csbjShow;
          this.jxmxShow = false;
          break;
        case "jxmx":
          this.jxmxShow = !this.jxmxShow;
          this.csbjShow = false;
          break;
      }
    },
    handleCommand(command) {

      switch (command) {
        case "spjkHandle":
          this.spjkHandle();
          break;
        case "closeSpjk":
          this.closeSpjk();
          break;
        case "stdsjHandle":
          this.stdsjHandle();
          break;
        case "bzdSystem":
          this.bzdSystem();
          break;
        case "fcfhHandle":
          this.fencengfenhu();
          break;
        case "sprhHandle":
          this.shipinronghe(this.videoList);
          break;
        case "sjxlHandle":
          this.shoujixinling();
          break;
        case "closeSjxl":
          this.closeSjxl();
          break;
        case "jiqirendahui":
          this.jiqirendahui(this.robotVideoList);
          break;
      }
    },
    historyHandle() {
      this.switchMenu(1);
      if (this.isLand) {
        this.$parent.changeMode("影像底图");
        if (!this.viewer1Show) {
          window.loading = this.$loading({
            lock: true,
            text: "影像对比功能加载中，请稍后",
            spinner: "el-icon-loading",
            background: "rgba(0, 0, 0, 0.7)",
          });
        }
        this.setIsLand(false);
        this.setViewer1Show(true);
      } else {
        if (!this.viewer1Show) {
          this.$parent.changeMode("影像底图");
          window.loading = this.$loading({
            lock: true,
            text: "影像对比功能加载中，请稍后",
            spinner: "el-icon-loading",
            background: "rgba(0, 0, 0, 0.7)",
          });
        }
        this.setIsLand(false);
        this.setViewer1Show(!this.viewer1Show);
      }
    },
    tdglHandle() {
      this.switchMenu(1);
      if (!this.isLand) {
        if (!this.viewer1Show) {
          let p = sgworld.Navigate.getCameraInfo();
          sgworld.Navigate.flyToPointsInterest({
            destination: new Cesium.Cartesian3.fromDegrees(
              p.location.lon,
              p.location.lat,
              p.location.height
            ),
            orientation: {
              heading: Cesium.Math.toRadians(0),
              pitch: Cesium.Math.toRadians(-90),
              roll: Cesium.Math.toRadians(0),
            },
          });
          window.loading = this.$loading({
            lock: true,
            text: "土地管理功能加载中，请稍后",
            spinner: "el-icon-loading",
            background: "rgba(0, 0, 0, 0.7)",
          });
        }
        this.setIsLand(true);
        this.setViewer1Show(true);
      } else {
        if (!this.viewer1Show) {
          let p = sgworld.Navigate.getCameraInfo();
          sgworld.Navigate.flyToPointsInterest({
            destination: new Cesium.Cartesian3.fromDegrees(
              p.location.lon,
              p.location.lat,
              p.location.height
            ),
            orientation: {
              heading: Cesium.Math.toRadians(0),
              pitch: Cesium.Math.toRadians(-90),
              roll: Cesium.Math.toRadians(0),
            },
          });
          window.loading = this.$loading({
            lock: true,
            text: "土地管理功能加载中，请稍后",
            spinner: "el-icon-loading",
            background: "rgba(0, 0, 0, 0.7)",
          });
        }
        this.setIsLand(true);
        this.setViewer1Show(!this.viewer1Show);
      }
    },
    stdsjHandle() {
      // window.location.href =
      //   "http://10.9.2.29:8080/#/login?token=1ed14c5157acb8088efe65bc93a032c3";
      window.open(
        "http://10.9.2.29:8080/#/login?token=1ed14c5157acb8088efe65bc93a032c3"
      );
    },
    switchMenu(id) {

      if (id != 1) {
        this.setViewer1Show(false);
      }
      if (id != 3) {
        this.closeSjxl();
      }
      if (id != 4) {
        this.closeSpjk();
      }
    },
    bzdSystem() {
      window.open("http://192.162.24.2:8076/login");
    },
    shoujixinling() {
      this.switchMenu(3);
      if (this.isShowSjxl) {
        this.isShowSjxl = false;
        this.$parent.signallingShow = true;
      } else {
        this.closeSjxl();
      }
    },
    closeSjxl() {
      
        this.isShowSjxl = true;
        this.$parent.signallingShow = false;

    },
    // historyHandle() {
    //   this.$store.commit("showHistory", true);
    // },
    sceneRoaming() {
      if (this.showFlag) {
        document.getElementById("scroll").style.display = "none";
      } else {
        document.getElementById("scroll").style.display = "block";
      }
      this.showFlag = !this.showFlag;
    },
    setRomanFly(result) {
      this.showFlag = false;
      document.getElementById("scroll").style.display = "none";
      var val = roman.filter((res) => {
        if (res.name == result.name) {
          return res;
        }
      });
      var degreesArr = val[0].value;

      sgworld.Creator.getFlyData(degreesArr, (data) => {
        data.showPoint = false;
        data.showLine = true;
        data.mode = 1;
        // 弹窗数据
        window.PathAnimationData = {
          flyData: data,
        };
        window.PathAnimationData.winIndex = layer.open({
          type: 2,
          title: "路径动画",
          shade: false,
          area: ["352px", "690px"],
          offset: "r",
          skin: "other-class",
          content: SmartEarthRootUrl + "Workers/path/Path.html",
          end: function () {
            PathAnimationData.fly && PathAnimationData.fly.exit();
          },
        });
      });
    },
    spjkHandle() {
      this.switchMenu(4);
      if (this.isShowSPJK) {
        const loading = this.$loading({
          lock: true,
          text: "视频点位数据加载中，请稍后",
          spinner: "el-icon-loading",
          background: "rgba(0, 0, 0, 0.7)",
        });
        setTimeout(() => {
          loading.close();
        }, 1500);
        this.isShowSPJK = false;
        if (window.sxtkGeojson) {
          window.sxtkGeojson.deleteObject();
          window.sxtkGeojson = null;
          window.sxthandler.destroy();
          //关闭弹窗
          Bus.$emit("closeRightPop", true);
          layuiLayer.close(SmartEarthPopupData.layerProp);
          return;
        } else {
          Bus.$emit("showSPJK");
          // this.spjkLoad();
        }
      } else {
        this.closeSpjk();
      }
    },
    closeSpjk() {
      if (!this.isShowSPJK) {
        this.isShowSPJK = true;
        if (window.sxtkGeojson) {
          window.sxtkGeojson.deleteObject();
          window.sxtkGeojson = null;
          window.sxthandler.destroy();
          //关闭弹窗
          Bus.$emit("closeRightPop", true);
          layuiLayer.close(SmartEarthPopupData.layerProp);
          return;
        } else {
          Bus.$emit("closeSPJK");
          // this.spjkLoad();
        }
      }
    },
    // 分层分户
    fencengfenhu() {
      Bus.$emit("switchImage");
      const loading = this.$loading({
        lock: true,
        text: "建筑实景模型加载中，请稍后",
        spinner: "el-icon-loading",
        background: "rgba(0, 0, 0, 0.7)",
      });
      setTimeout(() => {
        loading.close();
      }, 2000);
      Bus.$emit("ShowFCFH", true);
    },
    // 机器人大会视频融合
    async jiqirendahui(item) {
      Bus.$emit("switch3D");
      var that = this;
      this.isShowSPRH = false;
      if (that.robotvideoarrList.length > 0) {
        for (var i = 0; i < that.robotvideoarrList.length; i++) {
          that.robotvideoarrList[i].destroy();
          that.robotvideoarrList[i] = undefined;
        }
        that.robotvideoarrList = [];
        this.isShowSPRH = true;
      } else {
        const loading = this.$loading({
          lock: true,
          text: "视频数据加载中，请稍后",
          spinner: "el-icon-loading",
          background: "rgba(0, 0, 0, 0.7)",
        });
        for (var i = 0; i < item.length; i++) {
          let position = new SmartEarth.Degrees(
            item[i].lon,
            item[i].lat,
            item[i].height
          );
          await $.ajax({
            url:
              "http://10.10.4.116:8086/getCamerasInfoHls?cameraIndexCode=" +
              item[i].cameraIndexCode,
            // url: "http://10.10.4.116:8086/getCamerasInfoHls?cameraIndexCode=49ee9fed701444738112e80a4835122c",
            success: function (result) {
              video = sgworld.Creator.Video3D({
                cameraPosition: position, //相机安装位置
                heading: item[i].heading, //64
                pitch: item[i].pitch, //-47
                url: JSON.parse(result).data.url, //视频
                type: "hls",
                horizonAngle: item[i].horizonAngle, //相机水平视角30
                verticalAngle: item[i].verticalAngle, //相机垂直视角60
                offset: 0.1, //视频四周羽化比例
                near: 1, //最近投射面距离
                far: item[i].far, //最远投射面距离166
                alpha: item[i].alpha, //透明度1
                useLine: false, //是否试用辅助线
                success() {
                  sgworld.Navigate.flyToObj(video);
                  loading.close();
                },
              });
              that.robotvideoarrList.push(video);
            },
            error: () => {
              loading.close();
            },
          });
        }
      }
    },
    // 加载模型
    async shipinronghe(item) {
      var that = this;
      if (that.videoarrList.length > 0) {
        for (var i = 0; i < that.videoarrList.length; i++) {
          that.videoarrList[i].destroy();
          that.videoarrList[i] = undefined;
        }
        that.videoarrList = [];
      } else {
        const loading = this.$loading({
          lock: true,
          text: "视频融合加载中，请稍后",
          spinner: "el-icon-loading",
          background: "rgba(0, 0, 0, 0.7)",
        });

        for (var i = 0; i < item.length; i++) {
          let position = new SmartEarth.Degrees(
            item[i].lon,
            item[i].lat,
            item[i].height
          );
          await $.ajax({
            url:
              "http://10.10.4.116:8086/getCamerasInfoHls?cameraIndexCode=" +
              item[i].cameraIndexCode,
            // url: "http://10.10.4.116:8086/getCamerasInfoHls?cameraIndexCode=49ee9fed701444738112e80a4835122c",
            success: function (result) {
              loading.close();
              video = sgworld.Creator.Video3D({
                cameraPosition: position, //相机安装位置
                heading: item[i].heading, //64
                pitch: item[i].pitch, //-47
                url: JSON.parse(result).data.url, //视频
                type: "hls",
                horizonAngle: item[i].horizonAngle, //相机水平视角30
                verticalAngle: item[i].verticalAngle, //相机垂直视角60
                offset: 0.1, //视频四周羽化比例
                near: 1, //最近投射面距离
                far: item[i].far, //最远投射面距离166
                alpha: item[i].alpha, //透明度1
                useLine: false, //是否试用辅助线
                success() {
                  sgworld.Navigate.flyToObj(video);
                  loading.close();
                },
              });
              that.videoarrList.push(video);
            },
            error: function () {
              loading.closee();
            },
          });
        }
      }
    },
    updateVideo() {
      // console.log(this.robotVideoList[3]);
      video &&
        video.updateVideo({
          // horizonAngle: this.videoList[0].horizonAngle, //相机水平视角
          // verticalAngle: this.videoList[0].verticalAngle, //相机垂直视角
          // alpha: this.videoList[0].alpha, //透明度
          // far: this.videoList[0].far, //透明度
          // heading: this.videoList[0].heading, //透明度
          // pitch: this.videoList[0].pitch, //透明度
          horizonAngle: this.robotVideoList[3].horizonAngle, //相机水平视角
          verticalAngle: this.robotVideoList[3].verticalAngle, //相机垂直视角
          alpha: this.robotVideoList[3].alpha, //透明度
          far: this.robotVideoList[3].far, //透明度
          heading: this.robotVideoList[3].heading, //透明度
          pitch: this.robotVideoList[3].pitch, //透明度
        });
    },
    // 清除
    clear() {
      video && video.destroy();
      video = undefined;
    },
  },
};
</script>
